<template>
  <el-button v-if="show" :loading="loading" :icon="myIcon" :round="myRound" :plain="myPlain" :size="mySize" :type="myType" @click="click">
    {{ myName }}
  </el-button>
</template>
<script>
export default {
  name: 'MyButton',
  props: {
    checkPermission: {
      type: String,
      default: ''
    },
    type: {
      type: String,
      default: ''
    },
    name: {
      type: String,
      default: '按钮'
    },
    icon: {
      type: String,
      default: ''
    },
    size: {
      type: String,
      default: ''
    },
    plain: {
      type: Boolean,
      default: true
    },
    clazz: {
      type: String,
      default: ''
    }
  },
  data() {
    return {
      loading: false,
      myType: this.type, // 按钮类型
      myName: this.name, // 按钮名称
      myIcon: this.icon, // 按钮图标
      mySize: this.size, // 按钮大小
      myRound: false, // 是否圆角按钮
      myPlain: this.plain, // 是否朴素按钮
      show: true, // 是否显示
      myClazz: this.clazz
    }
  },
  created() {
    if (this.checkPermission != '' && this.$store.getters.myButtonPermission && this.$store.getters.myButtonPermission.indexOf(this.checkPermission) < 0) {
      this.show = false
    }
    const name = this.myName

    if (this.myClazz == 'tools') {
      if (name == '添加') {
        this.setDefault({
          myIcon: 'el-icon-circle-plus-outline',
          mySize: 'small'
        })
      } else if (name.includes('导入')) {
        this.setDefault({
          myIcon: 'el-icon-upload2',
          mySize: 'small'
        })
      } else if (name.includes('导出')) {
        this.setDefault({
          myIcon: 'el-icon-download',
          mySize: 'small'
        })
      }
      return
    }
    if (name == '搜索') {
      this.setDefault({
        myType: 'primary',
        myIcon: 'el-icon-search',
        mySize: 'small'
      })
    } else if (name == '重置') {
      this.setDefault({
        myType: 'success',
        myIcon: 'el-icon-refresh',
        mySize: 'small'
      })
    } else if (name == '保存' || name == '保 存') {
      this.setDefault({
        myType: 'primary',
        mySize: 'small'
      })
    } else if (name == '添加') {
      this.setDefault({
        myType: 'primary',
        myIcon: 'el-icon-edit',
        mySize: 'small'
      })
    } else if (name == '发布') {
      this.setDefault({
        myType: 'primary',
        myIcon: 'el-icon-plus',
        mySize: 'small'
      })
    } else if (name == '确定' || name == '确 定') {
      this.setDefault({
        myType: 'primary',
        mySize: 'small'
      })
    } else if (name.includes('导入')) {
      this.setDefault({
        myType: 'primary',
        myIcon: 'el-icon-upload2',
        mySize: 'small'
      })
    } else if (name.includes('导出')) {
      this.setDefault({
        myType: 'primary',
        myIcon: 'el-icon-download',
        mySize: 'small'
      })
    } else if (name == '批量删除') {
      this.setDefault({
        myType: 'danger',
        myIcon: 'el-icon-delete',
        mySize: 'small'
      })
    } else if (name == '编辑') {
      this.setDefault({
        myType: 'primary',
        mySize: 'mini',
        myPlain: true
      })
    } else if (name == '删除') {
      this.setDefault({
        myType: 'danger',
        mySize: 'mini',
        myPlain: true
      })
    } else if (name == '上架商品') {
      this.setDefault({
        myType: 'primary',
        myIcon: 'el-icon-edit',
        mySize: 'small'
      })
    } else {
      this.setDefault({
        myType: 'primary',
        mySize: 'small',
        myPlain: false
      })
    }
  },
  methods: {
    click() {
      this.loading = true
      this.$emit('click')
      setTimeout(() => {
        this.loading = false
      }, 1000)// 一秒内不能重复点击
    },
    setDefault(param) {
      Object.keys(param).forEach(key => {
        if (this[key] == '') {
          this[key] = param[key]
        }
      })
    }
  }
}
</script>
